//This work is licensed under a Creative Commons Attribution 3.0 Unported License.
//Original version by Daniel Davis, 2013
//danieldavis.com

import geomerative.*;

class ch1 extends ch_abstract
{
  public void ch1()
  {
  }
  
  @Override
  public void alphabet(String fileName)
  {
    setup();
    
    float detail = 70;
    float push_up = 0.05f;
    float number_lines = 170;
    
    //draw text as a black and white image on screen.
    
    fill(0);
    for(int i = 0; i < words.length; i++)
    {
      pushMatrix();
      translate( width/2, step_size * (i+1));
      font.draw(words[i]);
      popMatrix();
    }
      
    //blur edges of font (this causes the bend in the lines)
    filter(BLUR, 5);
      
      
    beginPDFRecord(fileName);
      strokeWeight(2);
      draw_over(detail, push_up, number_lines);
    endPDFRecord();
  }
 
  
  /**
   * Draws a set of horizontal lines over the current processing image. The lines move up based on the colour of image under line.
   * Detail: how much horizontal detail the line has.
   * Push: How far the lines are pushed up.
   * umber_lines: Number of horizontal lines.
   */
  private void draw_over(float detail, float push, float number_lines)
  {
    PImage background = get();//copy whatever is in the background of sketch into memory...
    background(255);
    fill(255);
    
    //now draw horizontal lines onto a new graphics, push the line upwards wherever the pixel under the point are dark.
    for(int i = 1; i < number_lines; i++ )
    {
      float y = i / number_lines * height;
      
      //change line colour based on how far down page it is.
      color c = colorMix((float) (i/number_lines));
      stroke(c);
      
      
      beginShape();
      curveVertex(0,  y);
    
      for(int j = 0; j < detail + 1; j++)
      {
        int x = (int) (j / detail * width);
        int pixel = background.get(x, (int)y);
        
        float final_y = y;
        if(pixel != 0)
        {
          final_y = y - (255-brightness(pixel)) * push;
        }
        curveVertex(x,  final_y);
      }
    
      curveVertex(width,  y);
      endShape();
    
    }
  }  
}


