//This work is licensed under a Creative Commons Attribution 3.0 Unported License.
//Original version by Daniel Davis, 2013
//danieldavis.com

import geomerative.*;

class ch2 extends ch_abstract
{
  public void ch2()
  {
  }

  @Override
  public void alphabet(String fileName)
  {
    setup();
    
    RCommand.setSegmentStep(0.5f);
    RCommand.setSegmentator(RCommand.UNIFORMSTEP);
    
    beginPDFRecord(fileName);
    
    for(int i = 0; i < words.length; i++)
    {
      pushMatrix();
      translate( width/2, step_size * (i+1));
      RGroup grp = font.toGroup(words[i]);
      RGeomElem[] letters = grp.elements;
      for(int n = 0; n < letters.length; n++)
      {
        RGeomElem letter = letters[n];
        scribble_letter(letter, 60 );
      }
      popMatrix();
    }
    
    endPDFRecord();
  }
  
  private void scribble_letter(RGeomElem letter, int maxDis)
  {
    RPoint[] pnts = letter.getPoints();
    
    stroke(blue, 100);
    strokeWeight(1);
    
    for(int i = 0; i < pnts.length; i++)
    {
      for(int j = i+1; j < pnts.length; j++)
      {  
        RPoint start = pnts[i];
        RPoint end = pnts[j]; 
        
        if(lineIntersectsShape(start, end, pnts)) continue;
        
        if(isLineInShape(start, end, pnts))
        {
          double distance = Math.sqrt(Math.pow(start.x - end.x, 2) + Math.pow(start.y - end.y, 2));
          if(distance > maxDis) continue; //distance = 70;
          
          color c = colorMix(1 - ((float)distance / maxDis));//(float) (count/ (float) number_of_lines));
          stroke(c, 100);
          lineFromPoint(start, end);
        }
        
      }
    }
  }
  


}

